<template>
  <main class="container">
    <div class="row py-3">
      <div class="col-10"></div>
      <div class="col-2">
        <select class="form-control" @change="changeLang($event.target.value)">
          <option value="en">English</option>
          <option value="de">Deutsch</option>
          <option selected="th">Thai</option>
        </select>
      </div>

      <div class="row">
        <div class="col-md-12">
          <h2>{{ t("title", {}, { locale: lang }) }}</h2>
          <p>{{ text }}</p>
          <button class="btn btn-outline-primary" @click="clickLike()">
            {{ t("like", {}, { locale: lang }) }}
          </button>
        </div>
      </div>
    </div>
  </main>
</template>

<script lang="ts">
import { defineComponent, ref } from "vue";
import axios from "axios";
import { useI18n } from "vue-i18n";

export default defineComponent({
  name: "App",
  setup() {
    const text = ref("");
    const lang = ref("th");
    const { t, locale } = useI18n();

    async function callBackend() {
      axios.defaults.headers["Accept-Language"] = lang.value;
      const response = await axios.get("http://192.168.202.12:8008/text");
      text.value = response.data.text;
    }

    async function changeLang(language: string) {
      lang.value = language;
      await callBackend();
    }

    async function clickLike() {
      const response = await axios.post("http://192.168.202.12:8008/like");
      const text = t(response.data.message, {}, { locale: lang.value });
      alert(text);
    }

    callBackend();

    return {
      text,
      lang,
      changeLang,
      t,
      locale,
      clickLike
    };
  }
});
</script>
